﻿using System;
using Windows.Media.Playlists;
using Windows.Storage;
using Windows.Storage.Pickers;
using Windows.Storage.Streams;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace KMusic
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        /// <summary>
        /// The active playlist in the executing scenario.
        /// </summary>
        private Playlist playlist;

        /// <summary>
        /// Audio file extensions.
        /// </summary>
        private static string[] audioExtensions = new string[] { ".wma", ".mp3", ".mp2", ".aac", ".adt", ".adts", ".m3u", ".wpl", ".zpl", ".m4a" };

        /// <summary>
        /// Playlist file extensions.
        /// </summary>
        private static string[] playlistExtensions = new string[] { ".m3u", ".wpl", ".zpl" };


        public MainPage()
        {
            this.InitializeComponent();

            mp.Stop();

            bAdd.Click += bAdd_Click;
            bPlay.Click += bPlay_Click;
        }

        void bPlay_Click(object sender, RoutedEventArgs e)
        {
            if (mp.CurrentState == MediaElementState.Playing)
                mp.Stop();

            mp.Play();
        }

        async void bAdd_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                //파일 선택 창 오픈
                FileOpenPicker picker = this.CreateFilePicker(MainPage.audioExtensions);
                //파일이 선택되면
                StorageFile file = await picker.PickSingleFileAsync();
                if (file != null)
                {
                    //파일을 열어서 스트림으로 만든다.(절대 경로 엑세스 불가)
                    IRandomAccessStream stream = await file.OpenAsync(FileAccessMode.Read);
                    //미디어 플레이어에 소스로 입력
                    mp.SetSource(stream, file.ContentType);
                }

                #region 삽질의 결과물
		            //var files = await picker.PickMultipleFilesAsync();
                    //if (files != null)
                    //{
                        //this.playlist = new Playlist();
                        //this.OutputStatus.Text = "Selected the following files:\n";
                        //foreach (StorageFile file in files)
                        //{
                        //    this.playlist.Files.Add(file);
                        //    //this.OutputStatus.Text += file.Name + "\n";
                        //    lbPlaylist.Items.Add(file.Name);
                        //    //playlist.
                        //}
                        //mp.Source = new Uri(playlist.Files.FirstOrDefault().Path, UriKind.Absolute);
                        //mp.Source = new Uri(mp.BaseUri, "Medias/2월첫주.wpl");
                        //mp.Source = new Uri(picker.SuggestedStartLocation.ToString(), "Medias/2월첫주.wpl");
                        //mp.Source = new Uri(mp.BaseUri, "Medias/001 티아라 - Lovey-Dovey.mp3");
                        //mp.Source = new Uri(PickerLocationId.MusicLibrary, "Medias/001 티아라 - Lovey-Dovey.mp3");
                        //String myFile = @"C:\Lovey-Dovey.mp3";
                        //Libraries\Music
                        //String myFile = @"D:\mp3\dance\01 I'm Back.mp3";
                        //FileOpenPicker picker = new FileOpenPicker();
                        //picker.FileTypeFilter.Add(".wmv");
                    //}
	            #endregion
            }
            catch (ArgumentException)
            {
                //this.OutputStatus.Text = "No audio files were selected.";
            }
        }

        /// <summary>
        /// Creates a FileOpenPicker for the specified extensions. 
        /// </summary>
        /// <param name="extensions">File extensions to pick.</param>
        /// <returns>FileOpenPicker instance.</returns>
        private FileOpenPicker CreateFilePicker(string[] extensions)
        {
            FileOpenPicker picker = new FileOpenPicker();
            //picker.SuggestedStartLocation = PickerLocationId.MusicLibrary;
            picker.SuggestedStartLocation = PickerLocationId.MusicLibrary;

            foreach (string extension in extensions)
            {
                picker.FileTypeFilter.Add(extension);
            }

            return picker;
        }
        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
        }
    }
}
